ScriptTitle=FileLauncher


HomeDir=%A_ScriptDir%
migemo_dict=%A_ScriptDir%\dict\migemo-dict
MigemoMin=2
ListMax=100
ListMaxRows=24
FontSize=9
width=400
posX=0
posY=0
AutoHide=0

;K\p
hModuleRegExp:=DllCall("LoadLibrary","Str","BREGEXP.DLL")
FileRegExp=m/^(((\w)\:)?.*\\)?((.*?)(\..*)?\\?)$/k
pRegExpFile=0
VarSetCapacity(RegExpMsg,256)

;GUIEBhE
Gui,Font,S%FontSize%
Gui,Margin,0,0
Gui,add,Edit,vKW gMatch w%width%
Gui,+Delimiter`n
Gui,add,ListBox,Multi -E0x00000200 w400 h300 vLst Delimiter`n,
GuiControl,Move,Lst,h0
Gui,+AlwaysOnTop +ToolWindow
Gui,Show,x%posX% y%posY% AutoSize,%ScriptTitle%

;FL_Settings.ahkɋLqꂽL[蓖Ăs
Gui,+LastFound
WinGet,myhwnd,id
Hotkey,IfWinActive,ahk_id %myhwnd%
GoSub,SetActions
Hotkey,IfWinActive
GoSub,SetGlobalActions
GoSub,SetMouseActions
OnExit,Exit
OnMessage(0x6,"OnActivate")

Gosub,LoadData
DeadList=
Mode=N
SetWorkingDir,%HomeDir%
return


Match:
	SetBatchLines,-1
	GuiControlGet,KW,,KW
	if KW=
	{
		if(mode="D"){
			GuiControl,-Redraw,Lst
			GuiControl,,Lst,`n
			GuiControl,,Lst,%DList%
			GuiControl,Choose,Lst,1
			GuiControl,+Redraw,Lst
		}else{
			GuiControl,,Lst,`n
		}
		GoSub,SetWinSize
		Searching=0
		return
	}
	
	
	GuiControl,-Redraw,Lst
	GuiControl,,Lst,`n

	NList=
	StringSplit,kws,KW,%A_SPACE%
	if LKW=
		pos=-1
	else
		StringGetPos,pos,KW,%LKW%
	If pos=0
	{
		;ÕL[[hɒǋLꂽꍇÃL[[ĥ݂ōi荞
		kws1:=kws%kws0%
		kws0=1
	}else{
		;ȊȌꍇAΏۃXgKXݒ
		if(Mode="D"){
			LList=%DList%
		}else if(Mode="C"){
			LList=%Commands%
		}else{
			LList=%Items%`n%List%
		}
	}
	Loop,%kws0%{
		k:=kws%A_Index%
		if k in ,/,\,>,<
			continue
		StringLeft,Chr,K,1
		if((Chr="/") && (Mode!="C")){
			break
		}else if Chr=`:
		{
			StringTrimLeft,k,k,1
			if(StrLen(k)<MigemoMin)
				continue
			MigemoSet(k)
			c=0
			Loop,PARSE,LList,`n,`r
			{
				if A_LoopField<>
				{
					if((c>=ListMax)||(MigemoMatch(A_LoopField))){
						c++
						NList=%NLIST%%A_LoopField%`n
					}
				}
			}
		}else{
			Loop,PARSE,LList,`n,`r
			{
				ifInString,A_LoopField,%k%
				{
					NList=%NLIST%%A_LoopField%`n
				}
			}
		}
		LList=%NList%
	}
	if NList=
		NList=%LList%
	GuiControl,-Redraw,Lst
	GuiControl,,Lst,`n
	StringGetPos,pos,NList,`n,L%ListMax%
	if pos>0
		StringLeft,NList,NList,%pos%
	GuiControl,,Lst,%NList%
	GuiControl,Choose,Lst,1
	GuiControl,+Redraw,Lst
	LKW=%KW%
	NList=
	Searching=0
	GoSub,SetWinSize
return

SetWinSize:
	SendMessage,0x1A1,0,0,ListBox1,ahk_id %myhwnd%
	s=%ErrorLevel%
	SendMessage,0x18B,0,0,ListBox1,ahk_id %myhwnd%
	if ErrorLevel>%ListMaxRows%
		s*=ListMaxRows
	else
		s*=ErrorLevel
	GuiControl,Move,Lst,h%s%
	Gui,Show,AutoSize NA %Hide%
return


/*
p
*/
MigemoSet(q){
	global hMigemo,migemo_ptn
	if hMigemo=
		GoSub,MigemoOpen
	pRegExpMigemo=0
	migemo_ptn:="m/" . DllCall("migemo.dll\migemo_query" ,"UInt",hMigemo ,"Str",q ,"Str") . "/ki"
}
MigemoMatch(target){
	global migemo_ptn,pRegExpMigemo,RegExpMsg
	pt:=&target
	pt2:=pt+StrLen(target)
	return (DllCall("BREGEXP.DLL\BMatch", "Str",migemo_ptn, "UInt",pt, "UInt",pt2, "UIntP",pRegExpMigemo, "Str",RegExpMsg, "Cdecl int")>0)
}
MigemoOpen:
	hModuleMigemo:=DllCall("LoadLibrary","Str","migemo.dll")
	hMigemo:=DllCall("migemo.dll\migemo_open" ,"Str",migemo_dict ,"UInt")
return

MigemoClose:
	if(hMigemo!=0){
		DllCall("migemo.dll\migemo_close" ,"UInt",hMigemo)
		DllCall("BREGEXP.DLL\BRegFree","Int",pRegExpMigemo)
		DllCall("FreeLibrary", "UInt", hModuleMigemo)
		hMigemo=
		migemo_ptn=
	}
return


/*
f[^Ǘ
*/
AddItem(str){
	global Items
	l:=VarSetCapacity(Items)
	VarSetCapacity(NItems,l+StrLen(str))
	NItems=%str%`n
	Loop,Parse,Items,`n,`r
	{
		If A_LoopField<>%str%
			If A_LoopField<>
				NItems=%NItems%%A_LoopField%`n
	}
	Items=%NItems%
}


LoadData:
FileRead,List,%A_ScriptDir%\path.txt
FileRead,Items,%A_ScriptDir%\items.txt
FileRead,Commands,%A_ScriptDir%\commands.txt
return

SaveItems:
	FileDelete,%A_ScriptDir%\items.txt
	FileAppend,%Items%,%A_ScriptDir%\items.txt
return

SavePath:
return

/*
}EXo^p
*/
SetMouseAction(msg,fwkeys,label){
	global
	fwkeys+=0
	msg+=0
	Mouse_%msg%_%fwkeys%=%label%
	OnMessage(msg,"MouseFunc")
}
MouseFunc(w,l,m,h){
	global
	local label
	if(A_GuiControl="Lst"){
		m+=0
		w:=w&12
		if(IsLabel(Mouse_%m%_%w%)){
			label:=Mouse_%m%_%w%
			GoSub,%label%
		}
	}
}
/*
֘A
*/
ClearKeyword:
	LKW=
	GuiControl,,KW
return
SetKeyword(k){
	global myhwnd
	LKW=
	GuiControl,,KW,%k%
	l:=StrLen(k)
	SendMessage,0xB1,%l%,%l%,Edit1,ahk_id %myhwnd%
}
GetKeyword(){
	GuiControlGet,kw,,KW
	return kw
}
Reset:
	LList=
	GuiControl,,KW
	GoSub,MigemoClose
	GoSub,ExitDir
return
Exit:
	Gosub,SaveItems
	ExitApp
return

/*
EBhE\
*/
AutoHide:
	AutoHide=1
return
NoAutoHide:
	AutoHide=0
return
ToggleAutoHide:
	AutoHide=!AutoHide
return
OnActivate(w,l,m,h){
	global AutoHide,Hide
	if((A_Gui=1)&&((w&0xFFF)=0)&(AutoHide=1)){
		Gosub,Hide
	}else{
		GuiControl,Move,Lst,h0
		Gui,Show,AutoSize NA %Hide%
	}
}


Show:
	ControlFocus,Edit1,ahk_id %myhwnd%
	Hide=
	Gui,Show
return
Hide:
	Hide=Hide
	Gui,Hide
	GoSub,Reset
return
GuiClose:
	Hide=Hide
	GoSub,Reset
return
ListPrev:
	ControlSend,ListBox1,{Up},ahk_id %myhwnd%
return

ListNext:
	ControlSend,ListBox1,{Down},ahk_id %myhwnd%
return


/*
It@C֘A	
*/
SGetInt(pStruct,offset){
	DllCall("RtlMoveMemory", UIntP,val, UInt,pStruct+offset, Int,4)
	return val
}
SplitPath(target, ByRef Drive, ByRef Dir, ByRef Name, ByRef Ext, ByRef NoExt){
	global
	local t,te,m,start,length,pArray1,pArray2
	t:=&target
	te:=t+StrLen(target)
	
	if(target=""){
		Drive=
		Dir=
		Name=
		Ext=
		NoExt=
		return
	}
	m:=DllCall("BREGEXP.DLL\BMatch", Str,FileRegExp, UInt,t, UInt,te, UIntP,pRegExpFile, Str,msg, "Cdecl int")
	if(m>0){
		pArray1:=SGetInt(pRegExpFile,32)
		pArray2:=SGetInt(pRegExpFile,36)
		
		start:=SGetInt(pArray1,4)+1-t
		length:=SGetInt(pArray2,4)+1-t-start
		StringMid,Dir,target,%start%,%length%
		
		start:=SGetInt(pArray1,12)+1-t
		length:=SGetInt(pArray2,12)+1-t-start
		StringMid,Drive,target,%start%,%length%
		
		start:=SGetInt(pArray1,16)+1-t
		length:=SGetInt(pArray2,16)+1-t-start
		StringMid,Name,target,%start%,%length%
		
		start:=SGetInt(pArray1,20)+1-t
		length:=SGetInt(pArray2,20)+1-t-start
		StringMid,NoExt,target,%start%,%length%
		
		start:=SGetInt(pArray1,24)+1-t
		length:=SGetInt(pArray2,24)+1-t-start
		StringMid,Ext,target,%start%,%length%
	}
	return m
}

SetVar:
	SetVar(GetSelectedPath())
return
SetVar(fname){
	global
	P=%fname%
	C=%Clipboard%
	SplitPath(fname,Drive,D,N,E,Name)
}

GetSelectedPath(){
	global Mode,DPath
	GuiControlGet,item,,Lst
	if item<>
	{
		if(Mode="D"){
			return DPath . item
		}else{
			StringSplit,str,item,%A_Tab%
			item:=str%str0%
			if(FileExist(item)){
				return item
			}else if(str0=1){
				DeadList:=%DeadList%%item%`n
				return
			}
		}
	}
}
GetSelectedItem(){
	GuiControlGet,item,,Lst
	return item
}

ExecCommand(c,args){
	global
	local label,str,cmdline,winstate,workingdir
	str=
	A=%args%
	if c=
		return
	StringSplit,A,args,%A_Space%
	IfInString,c,%A_Tab%
	{
		str=%c%
	}else{
		;R}h
		Loop,Parse,Commands,`n,`r
		{
			StringGetPos,pos,A_LoopField,/%c%%A_Tab%
			if(pos=0){
				str=%A_LoopField%
				break
			}
		}
		;R}hp
		if(str=""){
			if(IsLabel("FL_CMD_" . c)){
				label=FL_CMD_%c%
				GoSub,%label%
			}
			return
		}
	}
	StringSplit,str,str,%A_Tab%
	cmdline:=str%str0%
	str0--
	if str0>1
		workingdir:=str%str0%
	str0--
	if str0>1
		winstate:=str%str0%
	TransForm,cmdline,Deref,%cmdline%
;MsgBox,%cmdline%`n%workingdir%`n%winstate%
	Run,%cmdline%,%workingdir%,%winstate% UseErrorLevel
}

Execute:
	kw:=GetKeyword()
	if(kw="\"){
		Gosub,NormalMode
		return
	}else if(Mode="C"){
		StringGetPos,pos,kw,%A_Space%/
		StringTrimLeft,args,kw,% pos+1
		ExecCommand(GetSelectedItem(),args)
		Gosub,NormalMode
		return
	}else if(Mode="P"){
		str="%P%"
		extargs:=A_Space . """" . str . """"
		item:=GetSelectedItem()
		AddItem(item)
		Gosub,NormalMode
	}else if(Mode="A"){
		extargs:=A_Space . """" . GetSelectedPath() . """"
		item=%targetItem%
		Gosub,NormalMode
	}else{	;D,N
		StringRight,Chr,kw,1
		if(Chr="\"){
			Gosub,Open
			return
		}else if(Chr="/"){
			Gosub,SelectCommand
			return
		}else if(Chr="<"){
			Gosub,SelectArg
			return
		}else if(Chr=">"){
			Gosub,SelectProgram
			return
		}else if((kw="..") && (Mode="D")){
			GoSub,UpDir
			return
		}else{
			StringLeft,Chr,kw,1
			if(Chr="/"){
				pos=1
			}else{
				StringGetPos,pos,kw,%A_Space%/
				pos+=2
			}
			if pos<>1
			{
				;R}hŎs
				Gosub,SetVar
				StringTrimLeft,kw,kw,%pos%
				StringGetPos,pos,kw,%A_Space%
				if pos<>-1
				{
					StringLeft,cmd,kw,%pos%
					pos++
					StringTrimLeft,args,kw,%pos%
				}else{
					cmd=%kw%
					args=
				}
				ExecCommand(cmd,args)
				Gosub,ClearKeyword
				return
			}else{
				;ʏs
				extargs=
				item:=GetSelectedItem()
				AddItem(item)
			}
		}
	}
	;ACeeLXgWJ
	StringSplit,str,item,%A_Tab%
	cmdline:=str%str0%
	if(cmdline=""){
		return
	}
	str0--
	if str0>0
		workingdir:=str%str0%
	str0--
	if str0>0
		winstate:=str%str0%
	
	;R}hC̓ꃂ[hw
	StringLeft,Chr,cmdline,1
	if(Chr="/"){
		;R}hƂĎs
		StringGetPos,pos,cmdline,%A_Space%
		StringTrimLeft,args,cmdline,% pos+1
		StringMid,cmd,cmdline,2,% pos-1
		ExecCommand(cmd,args)
		GoSub,ClearKeyword
		return
	}else if(Chr="*"){
		;ϐWJĂs
		StringTrimLeft,cmdline,cmdline,1
		TransForm,cmdline,Deref,%cmdline%
	}
	Run,%cmdline%%extargs%,%workingdir%,%winstate% UseErrorLevel
	GoSub,ClearKeyword
return

ExitDir:
	if(Mode="D"){
		SetWorkingDir,%HomeDir%
		DPath=
		DList=
	}
return

NormalMode:
	Gosub,ExitDir
	Mode=N
	WinSetTitle,ahk_id %myhwnd%,,%ScriptTitle%
	GoSub,ClearKeyword
return

SelectCommand:
	Gosub,ExitDir
	Mode=C
	Gosub,SetVar
	WinSetTitle,ahk_id %myhwnd%,,Command for:%P%
	SetKeyword("/")
return

SelectProgram:
	Gosub,ExitDir
	Mode=P
	Gosub,SetVar
	WinSetTitle,ahk_id %myhwnd%,,Program for:%P%
	Gosub,ClearKeyword
return

SelectArg:
	Gosub,ExitDir
	Mode=A
	targetItem:=GetSelectedItem()
	Gosub,SetVar
	WinSetTitle,ahk_id %myhwnd%,,Argument for:%P%
	Gosub,ClearKeyword
return

/*
fBNg[h֘A
*/
Open:
	item:=GetSelectedPath()
	if(item){
		OpenDir(item)
	}
return


OpenDir(dir){
	global
	FileGetAttrib,attr,%dir%
	ifInString,attr,D
	{
		Mode=D
		SetWorkingDir,%dir%
		DPath=%dir%
		DList=
		GoSub,ClearKeyword
		Loop,%dir%*,1,0
		{
			IfInString,A_LoopFileAttrib,D
			{
				DList=%DList%%A_LoopFileName%\`n
			}else{
				DList=%DList%%A_LoopFileName%`n
			}
		}
		GuiControl,-Redraw,Lst
		GuiControl,,Lst,`n
		GuiControl,,Lst,%DList%
		GuiControl,Choose,Lst,1
		GuiControl,+Redraw,Lst
		WinSetTitle,ahk_id %myhwnd%,,%dir%
	}
}
UpDir:
	if,Mode=D
	{
		str=%DPath%
	}else{
		str:=GetSelectedPath()
		if str=
			return
	}
	SetVar(str)
	OpenDir(D)
return

#Include %A_ScriptDir%\FL_Settings.ahk
